#include <stdio.h>
#include <stdlib.h>

#define MAXN 200000
#define INPF "2dnim.in"

int positions[2][MAXN];								// Stores the positions of the points
int n;												// The number of the points
int sorted[2][MAXN];								// sorted[0] stores the indexes of the points sorted by the 
													// first coordinate, sorted[1] sorted by the second
int result[MAXN][3];
int result_sz = 0;

// Calculate the XOR sum of the current situation
int CalcXORSum()
{
	int i = 0;
	int j;
	int sum = 0;

	if (n % 2 == 0) i = 1;

	for (j = i;j < n;j += 2)
	{
		int tmp = positions[0][sorted[0][j]] - 1;
		if (j > 0) tmp -= positions[0][sorted[0][j - 1]];
		if (tmp  < 0)
			printf("sdgsd");
		sum ^= tmp;

		tmp = positions[1][sorted[1][j]] - 1;
		if (j > 0) tmp -= positions[1][sorted[1][j - 1]];
		if (tmp  < 0)
			printf("sdgsd");
		sum ^= tmp;
	}

	return sum;
}

// Compare function for sorting the points by the first coordinate
int cmpx(const void *a, const void *b)
{
	return positions[0][*((int*)a)] - positions[0][*((int*)b)];
}

// Compare function for sorting the points by the second coordinate
int cmpy(const void *a, const void *b)
{
	return positions[1][*((int*)a)] - positions[1][*((int*)b)];
}

// Compare function for sorting the result
int cmpres(const void *a, const void *b)
{
	int *res1 = (int*) a;
	int *res2 = (int*) b;
	if (res1[0] != res2[0]) return res1[0] - res2[0];
	if (res1[1] != res2[1]) return res1[1] - res2[1];
	return res1[2] - res2[2];
}

void Init()
{
	int i;

//	freopen("bgame.02.in", "rt", stdin);
	scanf("%d", &n);

	for (i = 0;i < n;i++)
	{
		scanf("%d%d", &positions[0][i], &positions[1][i]);
		sorted[0][i] = sorted[1][i] = i;
	}

	// Sort the points by first and second coordinate
	qsort(sorted[0], n, sizeof(sorted[0][0]), cmpx);
	qsort(sorted[1], n, sizeof(sorted[1][0]), cmpy);
}

void Solve()
{
	int i = 0, sum, j;

	if (n % 2 == 0) i = 1;

	sum = CalcXORSum();

	// Find the move that zeros the XOR sum
	for (j = i;j < n;j += 2)
	{
		for (int k = 0;k < 2;k++)
		{
			int currPileLength = positions[k][sorted[k][j]] - 1;
			if (j > 0) currPileLength -= positions[k][sorted[k][j - 1]];

			if ((currPileLength ^ sum) < currPileLength)
			{
				result[result_sz][0] = sorted[k][j];
				result[result_sz][1] = k + 1;
				result[result_sz][2] = currPileLength - (currPileLength ^ sum);
				result_sz++;
			}
			else if ((currPileLength ^ sum) > currPileLength && j > 1)
			{
				int additional = positions[k][sorted[k][j - 1]] - positions[k][sorted[k][j - 2]] - 1;
				if ((currPileLength ^ sum) <= currPileLength + additional)
				{
					result[result_sz][0] = sorted[k][j - 1];
					result[result_sz][1] = k + 1;
					result[result_sz][2] = (currPileLength ^ sum) - currPileLength;
					result_sz++;
				}
			}
		}
	}

	qsort(result, result_sz, sizeof(result[0]), cmpres);
}

void Output()
{
	int i;

	for (i = 0;i < result_sz;i++)
		printf("%d %d %d\n", result[i][0] + 1, result[i][1], result[i][2]);
}

int main()
{
	Init();
	Solve();
	Output();
	return 0;
}
