#include <fstream>
#include <string>
#include <iostream>
using namespace std;

int table[2050][2050];

void gen_type1(int aN)
{
	int count = 0;
	for (int i=1;i<=aN;i++)
	{
		for (int j=1;j<=aN;j++)
		{
			table[i][j] = ++count;
		}
	}
}

void gen_type2(int aN)
{
	int mx = 0;
	for (int i=1;i<=aN;i++)
	{
		for (int j=1;j<=aN;j++)
		{
			table[i][j] = mx + 1 + rand()%(i+1);
			if (table[i][j]<table[i-1][j]+table[i][j-1]-table[i-1][j-1])
				table[i][j]=table[i-1][j]+table[i][j-1]-table[i-1][j-1];
			mx = table[i][j];
		}
	}
}


void gen_type3(int aN,int aRow,int aCol)
{
	for (int i=1;i<=aN;i++)
	{
		for (int j=1;j<=aN;j++)
		{
			if (j==aN-i)
			{
				table[i][j] = 10;
			}
			if (j==aN-i+1)
			{
				table[i][j] = 30;
			}
			if (j==aN-i+2)
			{
				table[i][j] = 50;
			}
			if (j<aN-i)
			{
				table[i][j] = 0;
			}
			if (j>aN-i+2)
			{
				table[i][j] = table[i-1][j]+30;
			}
		}
	}

	table[aRow][aCol] = 20;
}


void gen_type4(int aN)
{
	int count = 0;
	for (int i=1;i<=aN;i++)
	{
		for (int j=1;j<=aN;j++)
		{
			table[j][i] = ++count;
		}
	}
}

void gen_type6(int aN,int aRow)
{
	for (int i = 1;i<=aN;i++)
	{
		table[1][i] = 0;
		table[i][1] = 0;
		table[aN][i] = 10000;
		table[i][aN] = 10000;
	}

	for (int i=2;i<aRow;i++)
	{
		for (int j=2;j<aN;j++)
		{
			table[i][j] = 0;
		}
	}

	for (int i=2;i<aN;i++)
	{
		table[aRow][i] = table[aRow][i-1] + 1 + rand()%10;
	}

	for (int i=2;i<=aN;i++)
	{
		for (int j=2;j<=aN;j++)
		{
			if (i<aRow+1 && j<aN) continue;
			table[i][j] = table[i-1][j] + table[i][j-1] - table[i-1][j-1];
			if (table[i][j] < 10000) table[i][j] = 10000;
		}
	}
}

void gen_type7(int aN,int aCol)
{
	for (int i = 1;i<=aN;i++)
	{
		table[1][i] = 0;
		table[i][1] = 0;
		table[aN][i] = 10000;
		table[i][aN] = 10000;
	}

	for (int i=2;i<aCol;i++)
	{
		for (int j=2;j<aN;j++)
		{
			table[j][i] = 0;
		}
	}

	for (int i=2;i<aN;i++)
	{
		table[i][aCol] = table[i-1][aCol] + 1 + rand()%10;
	}

	for (int i=2;i<=aN;i++)
	{
		for (int j=2;j<=aN;j++)
		{
			if (i<aCol+1 && j<aN) continue;
			table[j][i] = table[j-1][i] + table[j][i-1] - table[j-1][i-1];
			if (table[j][i] < 10000) table[j][i] = 10000;
		}
	}

}

void write(int testcase,int aN,int aRow,int aCol)
{
	char fname[64];
	sprintf(fname,"ceoi.%02d.in",testcase);

	ofstream fout(fname);

	fout<<aN<<" "<<aRow<<" "<<aCol<<endl;

	for (int i=1;i<=aN;i++)
	{
		for (int j=1;j<=aN;j++)
		{
			fout<<table[i][j]<<" ";
		}
		fout<<endl;
	}
	fout<<endl;
	fout.close();
}


int main () 
{

	srand(26);

	gen_type1(256);
	write(1,256,100,200);

	gen_type2(512);
	write(2,512,437,47);

	gen_type3(512,387,126);
	write(3,512,387,126);

	gen_type4(1024);
	write(4,1024,99,812);

	gen_type2(1024);
	write(5,1024,550,283);

	gen_type6(1024,768);
	write(6,1024,768,768);

	gen_type7(1024,256);
	write(7,1024,33,256);

	gen_type3(512,473,39);
	write(8,512,473,39);

	gen_type3(512,226,287);
	write(9,512,226,287);

	gen_type3(1024,749,275);
	write(10,1024,749,275);

	return 0;
}
